﻿;
; AutoHotkey Version: 1.1.30.00
; Language:       English
; Platform:       Optimized for Windows 10
; Author:         Sam.
;

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#Warn All, StdOut  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#SingleInstance Force  ; Skips the dialog box and replaces the old instance automatically, which is similar in effect to the Reload command.

Global A_Quote:=Chr(34)

; Copy imports and AHK
; Get Version from .ahk
; Update BINs
; Compile

;;;;; Copy Files ;;;;;
FileRecycle, D:\Program Files\GitHub Projects\PS-BAM\PS BAM*.exe
FileRecycle, D:\Program Files\GitHub Projects\PS-BAM\lib
FileRecycle, D:\Program Files\GitHub Projects\PS-BAM\PS BAM (files)

FileCopy, D:\AutoHotkey Scripts\PS BAM\PS BAM.ahk, D:\Program Files\GitHub Projects\PS-BAM\PS BAM.ahk, 1
FileCopy, D:\AutoHotkey Scripts\PS BAM\ToDo.txt, D:\Program Files\GitHub Projects\PS-BAM\ToDo.txt, 1
FileCopyDir, D:\AutoHotkey Scripts\PS BAM\lib, D:\Program Files\GitHub Projects\PS-BAM\lib, 1
FileCopyDir, D:\AutoHotkey Scripts\PS BAM\PS BAM (files), D:\Program Files\GitHub Projects\PS-BAM\PS BAM (files), 1




; rh.exe -open old.exe -save new.exe -action addoverwrite -res my.ico -mask ICONGROUP,159, -log CON
; rh.exe -open .\in\resources.rc -save .\out\resources.res -action compile -log CON
; rh.exe -open old.exe -save new.exe -action addoverwrite -res my.res -mask VERSIONINFO,1, -log CON

; Ahk2Exe.exe /in MyScript.ahk [/out MyScript.exe] [/icon MyIcon.ico] [/bin AutoHotkeySC.bin] [/mpress 0or1]

/*
		VALUE "FileDescription", "Graphically clock angular positions of protuberances from drawings."
		VALUE "FileVersion", "0.1.0"
		VALUE "InternalName", "GraphicalClock"
		VALUE "LegalCopyright", "Copyright \xA9 2018 Sam Schmitz - EV33"
		VALUE "OriginalFilename", "GraphicalClock.exe"
		VALUE "ProductName", "GraphicalClock"
		VALUE "ProductVersion", "0.1.0"
*/

;;;;; Dynamic Inputs ;;;;;
AHKPath:=A_ScriptDir "\PS BAM.ahk"

;;;;; Static Inputs ;;;;;
RHPath:="D:\Program Files\Resource Hacker\ResourceHacker.exe"
Bin32Path:="C:\AutoHotkey\Compiler\Unicode 32-bit.bin"
Bin64Path:="C:\AutoHotkey\Compiler\Unicode 64-bit.bin"
CompilerPath:="C:\AutoHotkey\Compiler\Ahk2Exe.exe"
IconPath:="D:\AutoHotkey Scripts\PS Icon 48x48.ico"

;;;;; Derived Inputs ;;;;;
FileGetVersion, AHKVersion, %Bin64Path%
DotVer:=GetPS_Version(AHKPath)
CommaVer:=TransformDotVer2CommaVer(DotVer)
RCPath:=A_ScriptDir "\tmp.rc"
StringReplace, RESPath, RCPath, .rc, .res, All
StringReplace, BINPath, RCPath, .rc, .bin, All
StringReplace, Out32, AHKPath, .ahk, .exe, All
SplitPath, AHKPath, , OutDir, , OutNameNoExt
Out64:=OutDir "\" OutNameNoExt "_x64.exe"


RC=
(

1 VERSIONINFO
FILEVERSION 0,0,0,0
PRODUCTVERSION 0,0,0,0
FILEOS 0x4
FILETYPE 0x1
{
BLOCK "StringFileInfo"
{
	BLOCK "040904b0"
	{
		VALUE "FileDescription", "An Infinity Engine BAM compressor, builder, and editor."
		VALUE "FileVersion", "0.0.0.0"
		VALUE "InternalName", "PS BAM"
		VALUE "LegalCopyright", "Copyright \xA9 2012-2022 Sam."
		VALUE "OriginalFilename", "PS BAM.exe"
		VALUE "ProductName", "PS BAM"
		VALUE "ProductVersion", "0.0.0.0"
		VALUE "AHKVersion", "_AHKVersion_"
	}
}

BLOCK "VarFileInfo"
{
	VALUE "Translation", 0x0409 0x04B0  
}
}


)
StringReplace, RC, RC, 0`,0`,0`,0, %CommaVer%, All
StringReplace, RC, RC, 0.0.0.0, %DotVer%, All
StringReplace, RC, RC, _AHKVersion_, %AHKVersion%, All
IfExist, %RCPath%
	FileDelete, %RCPath%
FileAppend, %RC%, %RCPath%

;;;;; Compile RC ;;;;;
Compile:=A_Quote RHPath A_Quote " -open " A_Quote RCPath A_Quote " -save " A_Quote RESPath A_Quote " -action compile -log CON`r`n"
Compile.="DEL " A_Quote RCPath A_Quote "`r`n"
;;;;; Compile 32-bit ;;;;;
Compile.=A_Quote RHPath A_Quote " -open " A_Quote Bin32Path A_Quote " -save " A_Quote BINPath A_Quote " -action addoverwrite -res " A_Quote IconPath A_Quote " -mask ICONGROUP,159, -log CON`r`n"
Compile.=A_Quote RHPath A_Quote " -open " A_Quote BINPath A_Quote " -save " A_Quote BINPath A_Quote " -action addoverwrite -res " A_Quote RESPath A_Quote " -mask VERSIONINFO,1, -log CON`r`n"
Compile.=A_Quote CompilerPath A_Quote " /in " A_Quote AHKPath A_Quote " /out " A_Quote Out32 A_Quote " /base " A_Quote BINPath A_Quote " /compress 0`r`n"
Compile.="DEL " A_Quote BINPath A_Quote "`r`n"
;;;;; Compile 64-bit ;;;;;
Compile.=A_Quote RHPath A_Quote " -open " A_Quote Bin64Path A_Quote " -save " A_Quote BINPath A_Quote " -action addoverwrite -res " A_Quote IconPath A_Quote " -mask ICONGROUP,159, -log CON`r`n"
Compile.=A_Quote RHPath A_Quote " -open " A_Quote BINPath A_Quote " -save " A_Quote BINPath A_Quote " -action addoverwrite -res " A_Quote RESPath A_Quote " -mask VERSIONINFO,1, -log CON`r`n"
Compile.=A_Quote CompilerPath A_Quote " /in " A_Quote AHKPath A_Quote " /out " A_Quote Out64 A_Quote " /base " A_Quote BINPath A_Quote " /compress 0`r`n"
Compile.="DEL " A_Quote BINPath A_Quote "`r`n"
Compile.="DEL " A_Quote RESPath A_Quote "`r`n"
;Compile.="Pause`r`n"

;;;;; Save BAT ;;;;;
IfExist, %A_ScriptDir%\Compile.bat
	FileDelete, %A_ScriptDir%\Compile.bat
FileAppend, %Compile%, Compile.bat
Sleep, 2000
RunWait, %A_ScriptDir%\Compile.bat
Sleep, 1000
IfExist, %A_ScriptDir%\Compile.bat
	FileDelete, %A_ScriptDir%\Compile.bat

ExitApp



GetPS_Version(Path){
	FileRead, File, %Path%
	Pos:=InStr(File,"PS_Version:=" A_Quote,0,1,1)
	Pos2:=InStr(File,A_Quote,0,Pos,2)
	Return SubStr(File,Pos+13,Pos2-Pos-13)
}

TransformDotVer2CommaVer(DotVer){
	StringReplace, DotVer, DotVer, ., `,, All
	Return RegExReplace(DotVer,"[a-zA-z]")
}

